function mask = apmask(pix_diam)
% mask = apmask(D)
% mask = apmask([D d])
% NiPe

N = round(pix_diam(1));

apdist = distmat(N);
mask = apdist<=N/2;

if length(pix_diam)==2
   if pix_diam(2) % if 0, we ignore
    M = round(pix_diam(2));
    if M > N
        error('inner diameter must be smaller')
    end
    
    mask2 = apdist<=M/2;
    
    mask = mask - mask2;
    end
end
 