function [ text phase_vec ef] = neural_network( param,relevant_data )
%UNTITLED3 Summary of this function goes here
%   Detailed explanation goes here


m=size(relevant_data,2);
n=zeros(1,size(relevant_data,2));
text=[];
s=isfield(param{1},'model');
ef=0;

numelx=0;
numely=0;
num_packets=0;

for i=1:m
    n(i)=size(relevant_data{i}.distances,1);
    distances=relevant_data{i}.distances;
    distances(distances==0)=1;
    if ~isfield(relevant_data{1},'sorting_index')
        metric=relevant_data{i}.metric_values;
        [sorted_distances,sorting_index]=sort(distances);
        conecting_line=relevant_data{i}.conecting_line;
        peak_values=zeros(n(i),1);
        conecting_line_5=conecting_line;
        extended_scl5=[];
        for j=1:n(i)  
            for f=j+1:n(i)
                cl5=interp1q((0:length(conecting_line{f,j})-1)',conecting_line{f,j},(0:(length(conecting_line{f,j})-1)/4:(length(conecting_line{f,j})-1))');
                conecting_line_5{f,j}=cl5;
                conecting_line_5{j,f}=cl5(5:-1:1);
                min_cl(f,j)=min(min(conecting_line{f,j}));
                mean_cl(f,j)=mean(mean(conecting_line{f,j}));
                min_cl(j,f)=min_cl(f,j);
                mean_cl(j,f)=mean_cl(f,j);
            end
            peak_values(j,1)=conecting_line{j,j+1-2*(j==n(i))}(1);
            sorted_min_cl(:,j)=min_cl(sorting_index(:,j),j);
            sorted_mean_cl(:,j)=mean_cl(sorting_index(:,j),j);
            sorted_conecting_line{:,j} = conecting_line{sorting_index(:,j),j};
            sorted_conecting_line_5{:,j} = conecting_line_5{sorting_index(:,j),j};
            sorted_metric(:,j) = metric(sorting_index(:,j),j);
            for f=j+1:n(i)
                aux=conecting_line_5{f,j};
                extended_scl5=[extended_scl5 ; aux(2:4)];
            end
        end
        area_zone=relevant_data{i}.area_zone';
        P_zone=relevant_data{i}.P_zone';
        sorted_airy=relevant_data{i}.airy_phase_vec(sorting_index);
        sorted_area_zone=area_zone(sorting_index);
        sorted_P_zone=P_zone(sorting_index);
        sorted_peak_values=peak_values(sorting_index);
        ponderated_metric=metric./distances;
        sorted_ponderated_metric=sorted_metric./sorted_distances;
        output=relevant_data{i}.best_phase_vec>0;
        sorted_output=output(sorting_index);
    elseif isfield(relevant_data{1},'dist_x')
        
        dist_x=relevant_data{i}.dist_x;
        dist_y=relevant_data{i}.dist_y;
        true_dist=(dist_x.^2+dist_y.^2).^0.5;
        apdiameter_meter=relevant_data{i}.apdiameter_meter;
        peak_values=relevant_data{i}.peak_values;
%         deviation=relevant_data{i}.deviation; 
        min_cl=relevant_data{i}.minimum; 
        mean_cl=relevant_data{i}.mean; 
        area_zone=relevant_data{i}.area_zone';
        P_zone=relevant_data{i}.P_zone';
        [sorted_distances,sorting_index]=sort(true_dist);
        clear('sorted_min_cl','sorted_mean_cl','sorted_dist_x','sorted_dist_y');
        for j=1:size(sorting_index,1)
%             sorted_deviation(:,j)=deviation(sorting_index(:,j),j);
%             keyboard
            sorted_min_cl(:,j)=min_cl(sorting_index(:,j),j);
            sorted_mean_cl(:,j)=mean_cl(sorting_index(:,j),j);
            sorted_dist_x(:,j)=dist_x(sorting_index(:,j),j);
            sorted_dist_y(:,j)=dist_y(sorting_index(:,j),j);
        end
        sorted_area_zone=area_zone(sorting_index);
        sorted_P_zone=P_zone(sorting_index);
        sorted_peak_values=peak_values(sorting_index);
%         sorted_airy=relevant_data{i}.airy_phase_vec(sorting_index);
        sorted_airy=zeros(size(sorting_index));
        output=relevant_data{i}.best_phase_vec>0;
    else
        peak_values=relevant_data{i}.peak_values;
        deviation=relevant_data{i}.deviation; 
        min_cl=relevant_data{i}.minimum; 
        mean_cl=relevant_data{i}.mean; 
        area_zone=relevant_data{i}.area_zone';
        P_zone=relevant_data{i}.P_zone';
        sorted_distances=relevant_data{i}.sorted_distances;  
        sorted_deviation=relevant_data{i}.sorted_deviation; 
        sorted_min_cl=relevant_data{i}.sorted_minimum; 
        sorted_mean_cl=relevant_data{i}.sorted_mean; 
        sorted_area_zone=relevant_data{i}.sorted_area_zone;
        sorted_P_zone=relevant_data{i}.sorted_P_zone;
        sorted_peak_values=relevant_data{i}.sorted_peak_values;
        [sorted_distances,sorting_index]=sort(distances);
        relevant_data{i}.sorting_index=sorting_index;
        sorted_airy=relevant_data{i}.airy_phase_vec(sorting_index);
        % fake value, we should pass the real ones 
        output=relevant_data{i}.best_phase_vec>0;
    end
    
    for k=1:size(param,2)
        
        
        numelx_=numelx;
        numely_=numely;
        eval(param{k}.y);
        
        numel0=numelx+1;
        eval(param{k}.x);
        
        sortedoutputs=sign(relevant_data{i}.best_phase_vec(sorting_index));
        for l=numel0:(numelx)
            p=l-numel0+2;
            if m>1
                sortedoutputs(sorting_index(:,p)>=p,p)=0;
                x2(l,:)=[x(l,:),sortedoutputs(2:4,p)'];
                np=1;
            else
                sortedoutputs(2:4,p)=0;
                sx=size(x,2);
                x2(l,:)=[x(l,:),zeros(1,3)];
                np=size(x2,1);
            end
        end
        
        
        
        x_{k}=x2;
        y_{k}=y;
        
        if i==1
%            numelx=0;
%            x=zeros(2500,size(x,2));
%            eval(param{k}.x);
        elseif i==m&&size(param,2)>1
           yt(:,k)=y_{k}; 
        end
        if numelx>=5000||i==m
            x_norm=(x_{k}(1:numelx,:)-ones(numelx,1)*param{k}.mu)./(ones(numelx,1)*param{k}.sigma);
            if k==size(param,2)
                numelx=0;
                num_packets=num_packets+1;
            end
            eval(['save x_norm' num2str(num_packets) '_' num2str(k) '.tmp x_norm']);
        end
        if k<size(param,2)
            numelx=numelx_;
            numely=numely_;
        end
    end
end

save num_packets.tmp num_packets;
clear x;
clear x_norm;


if size(param,2)==1||s==1
    yt=y_{1};
    clear y_;
    h=zeros(size(yt,1),size(yt,2));
end

clear y;

numely=1;
if np~=1
    eval(['aux=load([' 39 'x_norm1_1.tmp' 39 '],' 39 '-mat' 39 ');' ]);
end
sortedoutputs(sorting_index==1)=1;
for p=1:max(num_packets,np)
    
    if s==0
        for k=1:size(param,2)
            if np==1
                eval(['aux=load([' 39 'x_norm' 39 ' num2str(p) ' 39 '_' 39 ' num2str(k) ' 39 '.tmp' 39 '],' 39 '-mat' 39 ');' ]);
                a=aux.x_norm;
            else
                eval(['aux=load([' 39 'x_norm1_1.tmp' 39 '],' 39 '-mat' 39 ');' ]);
                a=aux.x_norm(p,:);
                a(sx+1:end)=sortedoutputs(2:4,p+1)';
            end
%             a=aux.x_norm;
            clear aux
            hidden_layers=size(param{k}.Theta,2)-1;
            for i=2:hidden_layers+2
                a=[ones(size(a,1),1) a];
                z=a*param{k}.Theta{i-1}.';
                a=sigmoid(z);
            end
            clear z
            if size(param,2)==1
                h(numely:numely+size(a,1)-1,:)=a;
                numely=numely+size(a,1);
                clear a
            else
                h(numely:numely+size(a,1)-1,k)=a;
                numely=numely+size(a,1);
                clear a
            end
            
            if np~=1
                sortedoutputs(sorting_index==(p+1))=sign(h(p,1)-0.5);
            end
        end
    else
        eval(['aux=load([' 39 'x_norm' 39 ' num2str(p) ' 39 '_' 39 ' num2str(k) ' 39 '.tmp' 39 '],' 39 '-mat' 39 ');' ]);
        x_(numely:numely+size(a,1)-1,:)=aux.x_norm;
        numely=numely+size(a,1);  
        clear aux
    end
    if np==1
        eval(['delete x_norm' num2str(p) '_' num2str(k) '.tmp']);
    elseif p==np
        eval(['delete x_norm1_' num2str(k) '.tmp']);
    end
end

if s==1
    [h,~,~] = svmpredict(yt, x_, param{1}.model);
    clear x_
end

yprima=yt>0;
clear yt
h=round(h*10);

peaks=max(size(yprima,1)/m,size(yprima,2));
correct=0;
correct_per_peak=zeros(1,max(n)-1);
n_zeros=zeros(1,max(n)-1);
correct_p=0;
total_p=0;
fields_no_zero=[];
phase_vec=zeros(max(n),1);
total_peaks=zeros(max(n)-1,1);
field=1;
i=1;

while i<size(yprima,1)
    phase_vec=zeros(max(n),1);
%     disp(['True Value     : ' num2str(yprima(i,:)) 13]);
%     disp(['Estimated Value: ' num2str(h(i,:)>=5) 13 13]);
    if size(yprima,2)>1
        correct_indexs=(yprima(i,:)==(h(i,:)>=5));
        correct=correct+sum(correct_indexs);
        pot=relevant_data{i}.P_zone(2:end); 
        correct_per_peak=correct_per_peak+correct_indexs;
        n_zeros=n_zeros+(yprima(i,:)==0);
        i=i+1;
        total_peaks=total_peaks+1;
    else
            phase_vec=zeros(max(n),1);
            phase_vec(1:n(field),1)=[1;(h(i:i+n(field)-2,1)>=5)];
            total_peaks(1:n(field)-1,1)=total_peaks(1:n(field)-1,1)+ones(n(field)-1,1);            
            correct_indexs=(yprima(i:i+n(field)-2,1)==(h(i:i+n(field)-2,1)>=5));
            correct=correct+sum(correct_indexs);
            pot=relevant_data{field}.P_zone(2:end);
            correct_per_peak(1:n(field)-1)=correct_per_peak(1:n(field)-1)+correct_indexs';
            n_zeros(1,1:n(field)-1)=n_zeros(1,1:n(field)-1)+(yprima(i:i+n(field)-2,1)==0)';
            i=i+n(field)-1;
            
    end
    field=field+1;
    correct_p=correct_p+sum(pot(correct_indexs));%+relevant_data{field-1}.P_zone(1);
    total_p=total_p+sum(pot);%+relevant_data{field-1}.P_zone(1);
end

ef=correct/(size(yprima,1)*(size(yprima,2)))*100;
text=[text 13 '---Predicted ' num2str(correct) ' correct values of ' num2str(size(yprima,1)*(size(yprima,2))) ', ' num2str(ef)  37 ' of efficiency.' 13 ];
if correct_p>0
    text=[text 13 '---Potency correctly predicted : ' num2str(correct_p/total_p*100)  37 13];
    text=[text 13 '---Correct predictions per peak: ' num2str(round(correct_per_peak*100./total_peaks'))];
%    text=[text 13 '---Number of zeros per peak    : ' num2str(round(n_zeros*100/m)) char(13)];
else
%     text=[text '---Number of 0s: ' num2str(round(n_zeros*100/m)) 13];
%     text=[text '---Fields with same phase of the first peak: '  num2str(fields_no_zero) 13];
end
text=[text 13 '---Number of zeros per peak    : ' num2str(round(n_zeros*100./total_peaks')) char(13)];
save('fields_no_zero.mat','fields_no_zero');

end

