function x = oddvec(M)
% ODDVEC(M)
% returns tth vector centered on 0
% oddvec deals with pixel distances


if length(M)~=1
    error('Input parameter is vector length');
end

xh = M/2;

if eq(xh, fix(xh))
    x = [-xh+0.5 : xh-0.5];
else
    xh = floor(xh);
    x = [-xh : xh];
end