function [ st_std_t ] = static_metrics_stadistics( data_t,cr_input )
%
%Makes stadistics of each individual treatment
%
    st_std_t.columns={'Index','strehl_impr','he_impr','he_impr_greater_than_1','strehl_impr_greater_than_1','power_in_zones','correct_power','best_power','r0_diameter','power_with_sign'};
    st_std_t.data=zeros(size(data_t.rows,2),size(st_std_t.columns,2));
    for i=1:size(st_std_t.columns,2)
        eval(['st_std_t.i',num2str(st_std_t.columns{i}),'=',num2str(i),';']);
    end
    st_std_t.data(:,st_std_t.iIndex)=data_t.data(:,data_t.iIndex);
    st_std_t.data(:,st_std_t.ipower_in_zones)=floor(10000*data_t.data(:,data_t.iZonesP)./data_t.data(:,data_t.iTotalP))/10000;
    st_std_t.data(:,st_std_t.ipower_with_sign)=floor(10000*data_t.data(:,data_t.iAsignedP)./data_t.data(:,data_t.iZonesP))/10000;
    st_std_t.data(:,st_std_t.icorrect_power)=floor(10000*data_t.data(:,data_t.iCorrectP)./data_t.data(:,data_t.iZonesP))/10000;
    st_std_t.data(:,st_std_t.ibest_power)=floor(10000*data_t.data(:,data_t.iBestAsignP)./data_t.data(:,data_t.iZonesP))/10000;
%     st_std_t.data(:,st_std_t.ir_with_best_power)=floor(10000*data_t.data(:,data_t.iCorrectP)./data_t.data(:,data_t.iBestAsignP))/10000;
    st_std_t.data(:,st_std_t.ir0_diameter)=floor(10000*data_t.data(:,data_t.ir0)./cr_input.data(:,cr_input.iapdiameter_meter))/10000;
    st_std_t.data((st_std_t.data(:,st_std_t.ir0_diameter)<0),st_std_t.ir0_diameter)=0;
    st_std_t.data(:,st_std_t.istrehl_impr)=floor(10000*data_t.data(:,data_t.iOutStrehl)./data_t.data(:,data_t.iInStrehl))/10000;
    st_std_t.data(:,st_std_t.ihe_impr)=floor(10000*data_t.data(:,data_t.iOutHE)./data_t.data(:,data_t.iInHE))/10000;
%     st_std_t.data(:,st_std_t.ihe_to_perfect)=floor(10000*data_t.data(:,data_t.iOutHE)./data_t.data(:,data_t.iPerfectHE))/10000;
%     st_std_t.data(:,st_std_t.istrehl_to_perfect)=floor(10000*data_t.data(:,data_t.iOutStrehl)./data_t.data(:,data_t.iPerfectStrehl))/10000;
    st_std_t.data(:,st_std_t.ihe_impr_greater_than_1)=st_std_t.data(:,st_std_t.ihe_impr)-0.99>0;
    st_std_t.data(:,st_std_t.istrehl_impr_greater_than_1)=st_std_t.data(:,st_std_t.istrehl_impr)-0.99>0;

end

