function outnum = zerninum(innum)
% outnum = zerninum(innum)

if size(innum,2)==1 % input is j
    j = innum;
    n = floor((1+sqrt(8*j-7))/2 - 1);
    m = j - (n+1).*n/2 - 1;
    
    nlogic = mod(n,2)==1;
    mlogic = mod(m,2)==1;
    m( ~mlogic & nlogic ) = m( ~mlogic & nlogic )+1;
    m( mlogic & ~nlogic ) = m( mlogic & ~nlogic )+1;
    outnum = [m n];
elseif size(innum,2)==2 % input is [m n]
    m = innum(:,1);
    n = innum(:,2);
    
    if (m>n) | (mod(sum(m+n)',2)==1)
        error('Wrong values for m.');
    end
    j = (n+1).*n/2 + m+1;
    
    % if m~=0 we need to add a second polynomial
    j2 = j;
    j2(m~=0) = j2(m~=0)-1;
    outnum = [j2 j];
else
    error('Wrong input size.');    
end

